## grok 1.20110708.1

=== Makefile ===
PACKAGE=grok

PLATFORM=$(shell (uname -o || uname -s) | tr -d "/" 2> /dev/null)
FLEX?=flex

FORCE_FLEX?=0

ifeq ($(PLATFORM), FreeBSD)
PREFIX?=/usr/local
else
PREFIX?=/usr
endif

ifeq ($(PLATFORM), Darwin)
LIBSUFFIX=dylib
else
LIBSUFFIX=so
endif

# On FreeBSD, you may want to set GPERF=/usr/local/bin/gperf since
# the base system gperf is too old.
ifeq ($(PLATFORM), FreeBSD)
GPERF?=/usr/local/bin/gperf
else
GPERF?=/usr/bin/gperf
endif

# For linux, we need libdl for dlopen()
# On FreeBSD, comment this line out.
ifeq ($(PLATFORM), GNULinux)
LDFLAGS+=-ldl
endif

# #############################################
# You probably don't need to make changes below

BASE?=.
MAJOR=$(shell sh $(BASE)/version.sh --major)
VERSION=$(shell sh $(BASE)/version.sh)

#CFLAGS+=-g
#LDFLAGS+=-g

CFLAGS+=-pipe -fPIC -I. -O2
LDFLAGS+=-lpcre -levent -rdynamic -ltokyocabinet

LIBSUFFIX=$(shell sh $(BASE)/platform.sh libsuffix)
VERLIBSUFFIX=$(shell sh $(BASE)/platform.sh libsuffix $(MAJOR))
DYNLIBFLAG=$(shell sh $(BASE)/platform.sh dynlibflag)
LIBNAMEFLAG=$(shell sh $(BASE)/platform.sh libnameflag $(MAJOR) $(INSTALLLIB))

# Sane includes
CFLAGS+=-I/usr/local/include
LDFLAGS+=-L/usr/local/lib

# Platform so we know what to dlopen
CFLAGS+=-DPLATFORM_$(PLATFORM)
# Uncomment to totally disable logging features
#CFLAGS+=-DNOLOGGING

EXTRA_CFLAGS?=
EXTRA_LDFLAGS?=
CFLAGS+=$(EXTRA_CFLAGS)
LDFLAGS+=$(EXTRA_LDFLAGS)

### End of user-servicable configuration

CLEANGEN=filters.c grok_matchconf_macro.c *.yy.c *.tab.c *.tab.h
CLEANOBJ=*.o *_xdr.[ch]
CLEANBIN=main grokre grok conftest grok_program
CLEANVER=VERSION grok_version.h grok.spec

GROKOBJ=grok.o grokre.o grok_capture.o grok_pattern.o stringhelper.o \
        predicates.o grok_capture_xdr.o grok_match.o grok_logging.o \
        grok_program.o grok_input.o grok_matchconf.o libc_helper.o \
        grok_matchconf_macro.o filters.o grok_discover.o
GROKPROGOBJ=grok_input.o grok_program.o grok_matchconf.o $(GROKOBJ)

GROKHEADER=grok.h grok_pattern.h grok_capture.h grok_capture_xdr.h \
           grok_match.h grok_logging.h grok_discover.h

# grok_version.h is generated by make.
GROKHEADER+=grok_version.h

.PHONY: all
all: grok discogrok libgrok.$(LIBSUFFIX) libgrok.$(VERLIBSUFFIX)

.PHONY: package create-package test-package update-version
package: 
	$(MAKE) $(MAKEFLAGS) create-package 
	$(MAKE) $(MAKEFLAGS) test-package 

install: libgrok.$(LIBSUFFIX) grok discogrok $(GROKHEADER)
	install -d $(DESTDIR)$(PREFIX)/bin
	install -d $(DESTDIR)$(PREFIX)/lib
	install -d $(DESTDIR)$(PREFIX)/include
	install -m 755 grok $(DESTDIR)$(PREFIX)/bin
	install -m 755 discogrok $(DESTDIR)$(PREFIX)/bin
	install -m 644 libgrok.$(LIBSUFFIX) $(DESTDIR)$(PREFIX)/lib
	for header in $(GROKHEADER); do \
		install -m 644 $$header $(DESTDIR)$(PREFIX)/include; \
	done 
	install -d $(DESTDIR)$(PREFIX)/share/grok
	install -d $(DESTDIR)$(PREFIX)/share/grok/patterns
	install patterns/base $(DESTDIR)$(PREFIX)/share/grok/patterns/

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/grok
	rm -f $(DESTDIR)$(PREFIX)/bin/discogrok
	rm -f $(DESTDIR)$(PREFIX)/lib/libgrok.$(LIBSUFFIX)
	for header in $(GROKHEADER); do \
		rm -f $(DESTDIR)$(PREFIX)/include/$$header; \
	done 
	rm -f $(DESTDIR)$(PREFIX)/share/grok/patterns/*

pre-create-package:
	rm -f VERSION grok_version.h

create-package: pre-create-package 
	$(MAKE) VERSION grok_version.h grok.spec
	PACKAGE=$(PACKAGE) sh package.sh $(VERSION)

test-package:
	PKGVER=$(PACKAGE)-$(VERSION); \
	tar -C /tmp -zxf $${PKGVER}.tar.gz; \
	echo "Running C tests..." && $(MAKE) -C /tmp/$${PKGVER}/test test-c

.PHONY: clean 
clean: cleanobj cleanbin

# reallyreallyclean also purges generated files
# we don't clean generated files in 'clean' target
# because some systems don't have the tools to regenerate
# the data, such as FreeBSD which has the wrong flavor
# of flex (not gnu flex)
.PHONY: reallyreallyclean
reallyreallyclean: reallyclean cleangen

.PHONY: reallyclean
reallyclean: clean cleanver

.PHONY: cleanobj
cleanobj:
	rm -f $(CLEANOBJ)

.PHONY: cleanbin
cleanbin:
	rm -f $(CLEANBIN)

.PHONY: cleangen
cleangen:
	rm -f $(CLEANGEN)

.PHONY: cleanver
cleanver:
	rm -f $(CLEANVER)

#.PHONY: test
#test:
	#$(MAKE) -C test test

# Binary creation
grok: LDFLAGS+=-levent
grok: $(GROKOBJ) conf.tab.o conf.yy.o main.o grok_config.o
	$(CC) $(LDFLAGS) $^ -o $@

discogrok: $(GROKOBJ) discover_main.o
	$(CC) $(LDFLAGS) $^ -o $@

libgrok.$(LIBSUFFIX): 
libgrok.$(LIBSUFFIX): $(GROKOBJ) 
	$(CC) $(LDFLAGS) -fPIC $(DYNLIBFLAG) $(LIBNAMEFLAG) $^ -o $@

libgrok.$(VERLIBSUFFIX): libgrok.$(LIBSUFFIX);
	ln -s $< $@

# File dependencies
# generated with: 
# for i in *.c; do grep '#include "' $i | fex '"2' | xargs | sed -e "s/^/$i: /"; done    
grok.h: grok_version.h
grok.c: grok.h
grok_capture.c: grok.h grok_capture.h grok_capture_xdr.h
grok_capture_xdr.c: grok_capture.h
grok_config.c: grok_input.h grok_config.h grok_matchconf.h grok_logging.h
grok_input.c: grok.h grok_program.h grok_input.h grok_matchconf.h grok_logging.h libc_helper.h
grok_logging.c: grok.h
grok_match.c: grok.h
grok_matchconf.c: grok.h grok_matchconf.h grok_matchconf_macro.h grok_logging.h libc_helper.h filters.h stringhelper.h
grok_pattern.c: grok.h grok_pattern.h
grok_program.c: grok.h grok_program.h grok_input.h grok_matchconf.h
grokre.c: grok.h predicates.h stringhelper.h grok_version.h
libc_helper.c: libc_helper.h
main.c: grok.h grok_program.h grok_config.h conf.tab.h
predicates.c: grok_logging.h predicates.h
stringhelper.c: stringhelper.h
filters.h: grok.h
grok.h: grok_logging.h grok_pattern.h grok_capture.h grok_match.h
grok_capture.h: grok_capture_xdr.h
grok_config.h: grok_program.h
grok_input.h: grok_program.h
grok_match.h: grok_capture_xdr.h
grok_matchconf.h: grok.h grok_input.h grok_program.h
predicates.h: grok.h


# Output generation
grok_capture_xdr.o: grok_capture_xdr.c grok_capture_xdr.h
grok_capture_xdr.c: grok_capture.x
	[ -f $@ ] && rm $@ || true
	rpcgen -c $< -o $@
grok_capture_xdr.h: grok_capture.x
	[ -f $@ ] && rm $@ || true
	rpcgen -h $< -o $@

%.c: %.gperf
	@if $(GPERF) --version | head -1 | egrep -v '3\.[0-9]+\.[0-9]+' ; then \
		echo "We require gperf version >= 3.0.3" ; \
		exit 1; \
	fi
	$(GPERF) $< > $@

conf.tab.c conf.tab.h: conf.y
	bison -d $<

conf.yy.c: conf.lex conf.tab.h
	@if $(FLEX) --version | grep '^flex version' ; then \
		if [ "$(FORCE_FLEX)" -eq 1 ] ; then \
			echo "Bad version of flex detected, but FORCE_FLEX is set, trying anyway."; \
			exit 0; \
		fi; \
		echo "Fatal - cannot build"; \
		echo "You need GNU flex. You seem to have BSD flex?"; \
		strings `which flex` | grep Regents; \
		echo "If you want to try your flex, anyway, set FORCE_FLEX=1"; \
		exit 1; \
	fi
	$(FLEX) -o $@ $<

.c.o:
	$(CC) -c $(CFLAGS) $< -o $@

%.1: %.pod
	pod2man -c "" -r "" $< $@

grok_version.h:
	sh $(BASE)/version.sh --header > $@

VERSION:
	sh $(BASE)/version.sh --shell > $@

grok.spec: grok.spec.template VERSION
	. ./VERSION;
	sed -e "s/^Version: .*/Version: $(VERSION)/" grok.spec.template > grok.spec


.PHONY: docs
docs:
	doxygen

.PHONY: package-debian
package-debian: debian
	CFLAGS="$(CFLAGS)" debuild -uc -us

package-debian-clean:
	rm -r debian || true

debian:
	dh_make -s -n -c bsd -e $$USER -p grok_$(VERSION) < /dev/null
	sed -i -e "s/Build-Depends:.*/&, bison, ctags, flex, gperf, libevent-dev, libpcre3-dev, libtokyocabinet-dev/" debian/control
	sed -i -e "s/Depends:.*/&, libevent-1.4-2 (>= 1.3), libtokyocabinet8 (>= 1.4.9), libpcre3 (>= 7.6)/" debian/control
	sed -i -e "s/^Description:.*/Description: A powerful pattern-matching and reacting tool./" debian/control
	sed -i -e "/^Description/,$$ { /^ *$$/d }" debian/control
	echo '#!/bin/sh' > debian/postinst
	echo '[ "$$1" = "configure" ] && ldconfig' >> debian/postinst
	echo 'exit 0' >> debian/postinst
	echo '#!/bin/sh' > debian/postrm
	echo '[ "$$1" = "remove" ] && ldconfig' >> debian/postrm
	echo 'exit 0' >> debian/postrm
	chmod 755 debian/postinst debian/postrm

=== test/Makefile ===
BASE=..
include ../Makefile
# Search these paths for dependency targets
VPATH=..:.

LDFLAGS+=-lcunit -levent
CFLAGS+=-I. -I.. -g $(EXTRA_CFLAGS)
CLEANOBJ=*.o *.gentest.c *_xdr.[hco] _*.c
CLEANBIN=*.test

TESTS=$(wildcard *.test.c)
#TESTS=grok_pattern.test.c grok_capture.test.c grok_simple.test.c 

.PHONY: test
test: test-c test-ruby

.PHONY: test-c
test-c:
	@for t in $(TESTS:.c=); do \
		./runtest.sh $$t; \
	done

.PHONY: test-ruby
test-ruby:
	$(MAKE) -C ../ruby/test test

%.c: gentest.sh

%.test.o: %.test.c 
	./gentest.sh $< > _$<
	$(CC) $(CFLAGS) -c _$< -o $@;
	rm _$<

$(GROKOBJ):
	make -C $(BASE) $@
	mv $(BASE)/$@ .

stringhelper.test: ../stringhelper.o
grok_pattern.test: $(GROKOBJ)
grok_capture.test: $(GROKOBJ)
grok_simple.test: $(GROKOBJ)
grok_manymanymany.test: $(GROKOBJ)
predicates.test: $(GROKOBJ)

%.test: %.test.o 
	$(CC) $(LDFLAGS) $(CFLAGS) $(^:cleanobj=) -o $@

=== ruby/test/Makefile ===

PLATFORM=$(shell (uname -o || uname -s) 2> /dev/null)

ifeq ($(PLATFORM), Darwin)
LIBSUFFIX=dylib
else
LIBSUFFIX=so
endif

.PHONY: test
test:
	$(MAKE) -C ../../ libgrok.$(LIBSUFFIX)
	LD_LIBRARY_PATH="$${LD_LIBRARY_PATH}:$$PWD/../../" RUBYLIB="$$PWD/../lib" ruby alltests.rb

test_jruby:
	$(MAKE) -C ../../ libgrok.$(LIBSUFFIX)
	LD_LIBRARY_PATH="$${LD_LIBRARY_PATH}:$$PWD/../../" RUBYLIB="$$PWD/../lib" jruby alltests.rb

=== debian/changelog ===
grok (1.20110708.1-7.1~exp1) experimental; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.

 -- Graham Inggs <ginggs@debian.org>  Wed, 31 Jan 2024 13:09:47 +0000

grok (1.20110708.1-7) unstable; urgency=medium

  * debian/control: Update Vcs-* with packaging repository

 -- Stig Sandbeck Mathisen <ssm@debian.org>  Thu, 14 Oct 2021 21:51:00 +0200

grok (1.20110708.1-6) unstable; urgency=medium

  * Add package tests

 -- Stig Sandbeck Mathisen <ssm@debian.org>  Sun, 26 Sep 2021 15:13:52 +0200

grok (1.20110708.1-5) unstable; urgency=medium

  * Build with TI RPC on GNU/Linux.
    Thanks to Aurelien Jarno <aurel32@debian.org> (Closes: #992917)
  * Update upstream URIs (Closes: #981689)
  * Bump standards version
  * Bump debhelper from deprecated 9 to 13.
  * Change priority extra to priority optional.
  * Update upstream homepage
  * Update upstream VCS headers
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Use secure copyright file specification URI.
  * Transition to automatic debug package (from: grok-dbg).
  * Replace build flag patches with variables in debian/rules
  * Manage patches with dgit
  * Update debian/watch for github upstream
  * Use DEB_*FLAGS_MAINT_* variables
  * Add lintian overrides for built binaries in the source tarball
  * Drop build dependency on dctrl-tools and dpkg-dev

 -- Stig Sandbeck Mathisen <ssm@debian.org>  Sun, 26 Sep 2021 12:15:18 +0200

grok (1.20110708.1-4.5) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with GCC-10. (Closes: #957309)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 25 Apr 2020 20:57:15 +0100

grok (1.20110708.1-4.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix ftbfs with GCC-9. (closes: #925708)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 13 Jan 2020 22:12:23 +0000

grok (1.20110708.1-4.3~deb9u1) stretch; urgency=medium

  * Non-maintainer upload.
  * Rebuild for stretch.
  * Drop the gperf 3.1 patches

 -- Andreas Beckmann <anbe@debian.org>  Mon, 27 Nov 2017 17:12:13 +0100

grok (1.20110708.1-4.3) unstable; urgency=medium

  * Non-maintainer upload.
  * libgrok-dev: Add the missing dependencies on:
    - libgrok1 (Closes: #875422)
    - libtokyocabinet-dev (Closes: #779034)

 -- Adrian Bunk <bunk@debian.org>  Sat, 14 Oct 2017 17:15:19 +0300

grok (1.20110708.1-4.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply Steve Langasek's fix for wrong pointer alias bug
    (Closes: #841668)
  * Apply patches to allow build grok with gperf >= 3.1
    (Closes: #869594)

 -- SZALAY Attila <sasa@debian.org>  Wed, 09 Aug 2017 16:36:26 -0400

grok (1.20110708.1-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply fix from upstream to working with PCRE >= 8.34
    (Closes: #775062)

 -- Neil Williams <codehelp@debian.org>  Fri, 16 Jan 2015 22:03:17 +0000

grok (1.20110708.1-4) unstable; urgency=low

  * Add GNU/Hurd patch which disappeared from -3 (Closes: #675104)

 -- Stig Sandbeck Mathisen <ssm@debian.org>  Sun, 14 Oct 2012 09:08:21 +0000

grok (1.20110708.1-3) unstable; urgency=low

  * Fix broken symlink for .so (Closes: #689947)
  * Fix FTBFS on kfreebsd-*

 -- Stig Sandbeck Mathisen <ssm@debian.org>  Fri, 12 Oct 2012 20:38:07 +0000

grok (1.20110708.1-2) unstable; urgency=low

  * Add documentation for the examples (Closes: #675881)
  * Also install "discogrok", and generate a manpage

 -- Stig Sandbeck Mathisen <ssm@debian.org>  Sat, 23 Jun 2012 14:00:40 +0200

grok (1.20110708.1-1) unstable; urgency=low

  * Initial Release (Closes: #672777)

 -- Stig Sandbeck Mathisen <ssm@debian.org>  Sun, 13 May 2012 17:24:56 +0200

=== debian/control ===
Source: grok
Section: misc
Priority: optional
Maintainer: Stig Sandbeck Mathisen <ssm@debian.org>
Build-Depends:
 bison,
 ctags,
 debhelper-compat (= 13),
 flex,
 gperf,
 help2man,
 libevent-dev,
 libpcre3-dev,
 libtirpc-dev,
 libtokyocabinet-dev,
Standards-Version: 3.9.3
Homepage: https://github.com/jordansissel/grok
Vcs-Browser: https://salsa.debian.org/debian/grok
Vcs-Git: https://salsa.debian.org/debian/grok.git

Package: grok
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: powerful pattern-matching and reacting tool
 The grok program can parse log data and program output. You can match
 any number of complex patterns on any number of inputs (processes and
 files) and have custom reactions.
 .
 Grok is simple software that allows you to easily parse logs and
 other files. With grok, you can turn unstructured log and event data
 into structured data.

Package: libgrok1t64
Provides: ${t64:Provides}
Replaces: libgrok1
Breaks: libgrok1 (<< ${source:Version})
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: shared libraries for grok
 The grok library provides the pattern matching features of grok in
 your own tools. There are currently C and Ruby APIs.
 .
 Grok is simple software that allows you to easily parse logs and
 other files. With grok, you can turn unstructured log and event data
 into structured data.

Package: libgrok-dev
Section: libdevel
Architecture: any
Depends:
 libgrok1t64 (= ${binary:Version}),
 libtokyocabinet-dev,
 ${misc:Depends},
 ${shlibs:Depends},
Provides: libgrok-dev
Conflicts: libgrok-dev
Description: development files for grok
 Development files for the grok pattern matcher
 .
 Grok is simple software that allows you to easily parse logs and
 other files. With grok, you can turn unstructured log and event data
 into structured data.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Build using TI RPC on GNU/Linux since glibc SunRPC implementation was removed
# in glibc 2.32
ifeq ($(DEB_HOST_ARCH_LIBC), gnu)
  DEB_CFLAGS_MAINT_APPEND  += -I/usr/include/tirpc
  DEB_LDFLAGS_MAINT_APPEND += -ltirpc
endif

# Build using -ldl on hurd and kfreebsd
ifneq ($(filter $(DEB_HOST_ARCH_OS),hurd kfreebsd),)
  DEB_LDFLAGS_MAINT_APPEND += -ldl
endif

# Add missing hardening flags
DEB_CFLAGS_MAINT_APPEND += -Wdate-time -D_FORTIFY_SOURCE=2

# Import build variables
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	# Move the library
	install -d debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/libgrok.so debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libgrok.so.1
	ln -s libgrok.so.1 debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libgrok.so

	help2man --no-info --section=1 \
		--version-string="discogrok $(DEB_VERSION)" \
		--name "Discover grok patterns in input" \
		$(CURDIR)/discogrok \
		> $(CURDIR)/debian/discogrok.1

override_dh_install:
	dh_install
	chmod 644 debian/grok/usr/share/grok/patterns/base

override_dh_installchangelogs:
	dh_installchangelogs -- CHANGELIST

override_dh_installexamples:
	dh_installexamples
	sed -i s,patterns/base,/usr/share/grok/patterns/base, debian/grok/usr/share/doc/grok/examples/*.grok

override_dh_strip:
	dh_strip --dbgsym-migration='grok-dbg (<< 1.20110708.1-5~)'

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/<project>-$1\.tar\.gz/ \
  https://github.com/jordansissel/grok/tags .*/v?(\d\S+)\.tar\.gz
